/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.gui.widgets.UnboundedRoller;

import java.util.ArrayList;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.gui.events.FloatValueModificationEvent;
import org.visnow.vn.gui.events.FloatValueModificationListener;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class ExtendedIntRoller extends javax.swing.JPanel
{

    private int initValue = 0;
    private int value = initValue;

    /**
     * Creates new form ExtendedUnboundedRoller
     */
    public ExtendedIntRoller()
    {
        initComponents();
        roller.addFloatValueModificationListener(new FloatValueModificationListener()
        {
            public void floatValueChanged(FloatValueModificationEvent e)
            {
                value = (int)e.getVal();
                spinner.setValue(value);
                fireStateChanged();
            }

        });
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        roller = new org.visnow.vn.gui.widgets.UnboundedRoller.UnboundedRoller();
        label = new javax.swing.JLabel();
        spinner = new javax.swing.JSpinner();

        setMinimumSize(new java.awt.Dimension(160, 22));
        setPreferredSize(new java.awt.Dimension(200, 25));
        setLayout(new java.awt.GridBagLayout());

        roller.setMinimumSize(new java.awt.Dimension(60, 20));
        roller.setName("roller"); // NOI18N
        roller.setPreferredSize(new java.awt.Dimension(100, 20));

        javax.swing.GroupLayout rollerLayout = new javax.swing.GroupLayout(roller);
        roller.setLayout(rollerLayout);
        rollerLayout.setHorizontalGroup(
            rollerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 66, Short.MAX_VALUE)
        );
        rollerLayout.setVerticalGroup(
            rollerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 24, Short.MAX_VALUE)
        );

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 140;
        gridBagConstraints.ipady = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        add(roller, gridBagConstraints);

        label.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        label.setText("label");
        label.setMaximumSize(new java.awt.Dimension(70, 15));
        label.setMinimumSize(new java.awt.Dimension(70, 15));
        label.setName("label"); // NOI18N
        label.setPreferredSize(new java.awt.Dimension(70, 15));
        label.setRequestFocusEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        add(label, gridBagConstraints);

        spinner.setModel(new javax.swing.SpinnerNumberModel());
        spinner.setMinimumSize(new java.awt.Dimension(60, 20));
        spinner.setName("spinner"); // NOI18N
        spinner.setPreferredSize(new java.awt.Dimension(70, 18));
        spinner.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                spinnerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        add(spinner, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void spinnerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_spinnerStateChanged
    {//GEN-HEADEREND:event_spinnerStateChanged
        value = (int)spinner.getValue();
        roller.setOutValue(value);
        fireStateChanged();
    }//GEN-LAST:event_spinnerStateChanged

    public void setLabel(String label)
    {
        this.label.setText(label);
    }

    public int getValue()
    {
        return value;
    }

    public void setValue(int value)
    {
        this.value = value;
        roller.setOutValue(value);
        spinner.setValue(value);
        fireStateChanged();
    }

    public void setInitValue(int initValue)
    {
        this.initValue = initValue;
    }

    public void setSensitivity(float sensitivity)
    {
        roller.setSensitivity(sensitivity);
    }

    public void setLargeIncrement(int increment)
    {
        roller.setLargeIncrement(increment);
    }

    public void reset()
    {
        value = initValue;
        roller.setOutValue(value);
        spinner.setValue(value);
        fireStateChanged();
    }

    public boolean isAdjusting()
    {
        return roller.isAdjusting();
    }

    /**
     * Utility field holding list of ChangeListeners.
     */
    private transient ArrayList<ChangeListener> changeListenerList
        = new ArrayList<ChangeListener>();

    /**
     * Registers ChangeListener to receive events.
     * <p>
     * @param listener The listener to register.
     */
    public synchronized void addChangeListener(ChangeListener listener)
    {
        changeListenerList.add(listener);
    }

    /**
     * Removes ChangeListener from the list of listeners.
     * <p>
     * @param listener The listener to remove.
     */
    public synchronized void removeChangeListener(ChangeListener listener)
    {
        changeListenerList.remove(listener);
    }

    /**
     * Notifies all registered listeners about the event.
     *
     * @param object Parameter #1 of the <CODE>ChangeEvent<CODE> constructor.
     */
    public void fireStateChanged()
    {
        ChangeEvent e = new ChangeEvent(this);
        for (ChangeListener listener : changeListenerList)
            listener.stateChanged(e);
    }

    private boolean enabled = true;

    @Override
    public void setEnabled(boolean enabled)
    {
        this.enabled = enabled;
        label.setEnabled(enabled);
        roller.setEnabled(enabled);
        spinner.setEnabled(enabled);
    }

    @Override
    public boolean isEnabled()
    {
        return enabled;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JLabel label;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.UnboundedRoller roller;
    protected javax.swing.JSpinner spinner;
    // End of variables declaration//GEN-END:variables
}
